import { Readable, Writable } from "svelte/store";
declare type ValidationError = string | readonly string[] | undefined;
declare type Validator<T> = (v: T) => string | readonly string[] | undefined;
export declare type TransactionStore<T> = Writable<T> & {
    readonly commit: () => void;
    readonly cancel: () => void;
    readonly hasChanges: Readable<boolean>;
    readonly validationError: Readable<ValidationError>;
};
export declare function transactionStore<T>(store: Writable<T>, validator?: Validator<T>): TransactionStore<T>;
export {};
